package com.ynet.life.filter;

import com.ynet.life.base.Trace;
import java.io.IOException;
import javax.servlet.Filter;
import javax.servlet.FilterChain;
import javax.servlet.FilterConfig;
import javax.servlet.ServletException;
import javax.servlet.ServletRequest;
import javax.servlet.ServletResponse;
import javax.servlet.http.HttpServletRequest;

public class DefeatCSRFFilter implements Filter {

   public void destroy() {
   }

   public void doFilter(ServletRequest sb, ServletResponse response, FilterChain chain) throws IOException, ServletException {
      HttpServletRequest httpRequest;
      String referer = (httpRequest = (HttpServletRequest)sb).getHeader("Referer");
      String domain;
      if((domain = httpRequest.getParameter("appKey")) != null && domain.length() > 0 && referer != null && referer.length() > 0) {
         domain = this.getDomain(referer);
         String host = this.getDomain(httpRequest.getRequestURL().toString());
         if(!domain.equals(host)) {
            Trace.logWarning("LifeSecurity", "EBLN:2002  用户遭遇跨站脚本攻击，攻击来源:" + referer + ",攻击链接:" + httpRequest.getRequestURL());
            response.setCharacterEncoding("UTF-8");
            StringBuffer sb1;
            (sb1 = new StringBuffer("{")).append("\"ec\":\"EBLN2002").append("\",");
            sb1.append("\"em\":\"您目前点击的链接非本站链接，可能遭受跨站脚本攻击，请退出网银并联系银行客服!").append("\"");
            sb1.append("}");
            response.getOutputStream().write(sb1.toString().getBytes("UTF-8"));
            return;
         }
      }

      chain.doFilter(sb, response);
   }

   private String getDomain(String domain) {
      int pos = domain.indexOf("//");
      if((pos = (domain = domain.substring(pos + 2)).indexOf("/")) > 0) {
         domain = domain.substring(0, pos);
      }

      if((pos = domain.indexOf(":")) > 0) {
         domain = domain.substring(0, pos);
      }

      return domain;
   }

   public void init(FilterConfig filterConfig) throws ServletException {
   }
}
